package com.zd.laboratory.mapper;

import com.zd.laboratory.domain.LabApproval;
import com.zd.laboratory.domain.dto.LabApprovalAndDetailDTO;
import com.zd.laboratory.domain.vo.LabApprovalVO;

import java.util.List;
import java.util.Map;

/**
 * 安全准入审批记录Mapper接口
 *
 * @author zd
 * @date 2021-08-31
 */
public interface LabApprovalMapper {
    /**
     * 查询安全准入审批记录
     *
     * @param id 安全准入审批记录主键
     * @return 安全准入审批记录
     */
    public LabApprovalAndDetailDTO selectLabApprovalById(Long id);

    /**
     * 查询安全准入审批记录列表
     *
     * @param labApproval 安全准入审批记录
     * @return 安全准入审批记录集合
     */
    public List<LabApprovalVO> selectLabApprovalList(LabApproval labApproval);


    /**
     * 根据安全准入配置表id查询安全准入审批记录列表
     *
     * @param labApproval 安全准入审批记录
     * @return 安全准入审批记录集合
     */
    public List<LabApprovalVO> selectLabApprovalListBySecurityGroupId(LabApproval labApproval);


    /**
     * 新增安全准入审批记录
     *
     * @param labApproval 安全准入审批记录
     * @return 结果
     */
    public int insertLabApproval(LabApproval labApproval);

    /**
     * 修改安全准入审批记录
     *
     * @param labApproval 安全准入审批记录
     * @return 结果
     */
    public int updateLabApproval(LabApproval labApproval);

    /**
     * 删除安全准入审批记录
     *
     * @param id 安全准入审批记录主键
     * @return 结果
     */
    public int deleteLabApprovalById(Long id);

    /**
     * 批量删除安全准入审批记录
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteLabApprovalByIds(Long[] ids);

    /**
     * 统计安全准入审批不同列表信息
     *
     * @param labApproval
     * @return 统计安全准入审批不同列表信息
     */
    public LabApprovalVO getApprovalCount(LabApproval labApproval);


    /**
     * 查询安全准入审批记录列表
     *
     * @param labApproval 安全准入审批记录
     * @return 查询安全准入审批记录列表
     */
    public List<LabApprovalVO> getApprovalList(LabApproval labApproval);

    List<LabApprovalVO> selectApprovalListByUser(LabApproval labApproval);

    int updateExpirationDate(Long id);

    List<Map<String, Object>> statistics(LabApproval labApproval);


    /**
     * 查询实验室安全证书
     *
     * @param joinUserId 用户id
     * @return boolean
     */
    public List<LabApprovalVO> selectLabCardByUserid(Long joinUserId);
}
